Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 100)
@@ -46,4 +46,8 @@
 // ====================================================================================================================
 
+#if LGE_EDGE_INTRA
+#define MAX_DISTANCE_EDGEINTRA 255
+#endif
+
 TComPrediction::TComPrediction()
 : m_pLumaRecBuffer(0)
@@ -419,4 +423,185 @@
 }
 
+#if LGE_EDGE_INTRA
+Void TComPrediction::predIntraLumaEdge ( TComDataCU* pcCU, TComPattern* pcTComPattern, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Pel* piPred, UInt uiStride, Bool bDelta )
+{
+  Pel *piDst = piPred;
+  Int *piSrc;
+  Int iSrcStride = ( iWidth<<1 ) + 1;
+  Int iDstStride = uiStride;
+
+  piSrc = pcTComPattern->getPredictorPtr( 0, g_aucConvertToBit[ iWidth ] + 2, m_piYuvExt );
+
+  xPredIntraEdge ( pcCU, uiAbsPartIdx, iWidth, iHeight, piSrc, iSrcStride, piDst, iDstStride
+#if LGE_EDGE_INTRA_DELTA_DC
+    , bDelta
+#endif
+    );
+}
+
+Pel  TComPrediction::xGetNearestNeighbor( Int x, Int y, Int* pSrc, Int srcStride, Int iWidth, Int iHeight, Bool* bpRegion )
+{
+  Bool bLeft = (x < y) ? true : false;
+  Bool bFound = false;
+  Int  iFoundX = -1, iFoundY = -1;
+  Int  cResult = 0;
+
+  UChar* piTopDistance = new UChar[iWidth];
+  UChar* piLeftDistance = new UChar[iHeight];
+
+  for( Int i = 0; i < iWidth; i++ )
+  {
+    int Abs = x > i ? x - i : i - x;
+    piTopDistance[ i ] = y + Abs;
+
+    Abs = y > i ? y - i : i - y;
+    piLeftDistance[ i ] = x + Abs;
+  }
+
+  for( Int dist = 0; dist < MAX_DISTANCE_EDGEINTRA && !bFound; dist++ )
+  {
+    if( !bLeft )
+    {
+      for( Int i = 0; i < iWidth; i++ )
+      {
+        if( piTopDistance[ i ] == dist )
+        {
+          if( bpRegion[ i ] == bpRegion[ x + y * iWidth ] )
+          {
+            iFoundX = i;
+            iFoundY = 0;
+            bFound = true;
+          }
+        }
+      }
+      for( Int i = 0; i < iHeight; i++ )
+      {
+        if( piLeftDistance[ i ] == dist )
+        {
+          if( bpRegion[ i * iWidth ] == bpRegion[ x + y * iWidth ] )
+          {
+            iFoundX = 0;
+            iFoundY = i;
+            bFound = true;
+          }
+        }
+      }
+    }
+    else
+    {
+      for( Int i = 0; i < iHeight; i++ )
+      {
+        if( piLeftDistance[ i ] == dist )
+        {
+          if( bpRegion[ i * iWidth ] == bpRegion[ x + y * iWidth ] )
+          {
+            iFoundX = 0;
+            iFoundY = i;
+            bFound = true;
+          }
+        }
+      }
+      for( Int i = 0; i < iWidth; i++ )
+      {
+        if( piTopDistance[ i ] == dist )
+        {
+          if( bpRegion[ i ] == bpRegion[ x + y * iWidth ] )
+          {
+            iFoundX = i;
+            iFoundY = 0;
+            bFound = true;
+          }
+        }
+      }
+    }
+  }
+
+  if( iFoundY == 0 )
+  {
+    cResult = pSrc[ iFoundX + 1 ];
+  }
+  else // iFoundX == 0
+  {
+    cResult = pSrc[ (iFoundY + 1) * srcStride ];
+  }
+
+  delete[] piTopDistance;  piTopDistance = NULL;
+  delete[] piLeftDistance; piLeftDistance = NULL;
+
+  assert( bFound );
+
+  return cResult;
+}
+
+Void TComPrediction::xPredIntraEdge( TComDataCU* pcCU, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, Bool bDelta )
+{
+  Pel* pDst = rpDst;
+  Bool* pbRegion = pcCU->getEdgePartition( uiAbsPartIdx );
+
+  // Do prediction
+  {
+    //UInt uiSum0 = 0, uiSum1 = 0;
+    Int iSum0 = 0, iSum1 = 0;
+    //UInt uiMean0, uiMean1;
+    Int iMean0, iMean1;
+    //UInt uiCount0 = 0, uiCount1 = 0;
+    Int iCount0 = 0, iCount1 = 0;
+    for( UInt ui = 0; ui < iWidth; ui++ )
+    {
+      if( pbRegion[ ui ] == false )
+      {
+        iSum0 += (pSrc[ ui + 1 ]);
+        iCount0++;
+      }
+      else
+      {
+        iSum1 += (pSrc[ ui + 1 ]);
+        iCount1++;
+      }
+    }
+    for( UInt ui = 0; ui < iHeight; ui++ ) // (0,0) recount (to avoid division)
+    {
+      if( pbRegion[ ui * iWidth ] == false )
+      {
+        iSum0 += (pSrc[ (ui + 1) * srcStride ]);
+        iCount0++;
+      }
+      else
+      {
+        iSum1 += (pSrc[ (ui + 1) * srcStride ]);
+        iCount1++;
+      }
+    }
+    if( iCount0 == 0 )
+      assert(false);
+    if( iCount1 == 0 )
+      assert(false);
+    iMean0 = iSum0 / iCount0; // TODO : integer op.
+    iMean1 = iSum1 / iCount1;
+#if LGE_EDGE_INTRA_DELTA_DC
+    if( bDelta ) 
+    {
+      Int iDeltaDC0 = pcCU->getEdgeDeltaDC0( uiAbsPartIdx );
+      Int iDeltaDC1 = pcCU->getEdgeDeltaDC1( uiAbsPartIdx );
+      xDeltaDCQuantScaleUp( pcCU, iDeltaDC0 );
+      xDeltaDCQuantScaleUp( pcCU, iDeltaDC1 );
+      iMean0 = Clip( iMean0 + iDeltaDC0 );
+      iMean1 = Clip( iMean1 + iDeltaDC1 );
+    }
+#endif
+    for( UInt ui = 0; ui < iHeight; ui++ )
+    {
+      for( UInt uii = 0; uii < iWidth; uii++ )
+      {
+        if( pbRegion[ uii + ui * iWidth ] == false )
+          pDst[ uii + ui * dstStride ] = iMean0;
+        else
+          pDst[ uii + ui * dstStride ] = iMean1;
+      }
+    }
+  }
+}
+#endif
+
 #if DEPTH_MAP_GENERATION
 Void TComPrediction::motionCompensation( TComDataCU* pcCU, TComYuv* pcYuvPred, RefPicList eRefPicList, Int iPartIdx, Bool bPrdDepthMap, UInt uiSubSampExpX, UInt uiSubSampExpY )
@@ -569,5 +754,11 @@
   {
     UInt uiRShift = 0;
-    xPredInterPrdDepthMap( pcCU, pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPredDepthMap(), uiPartAddr, &cMv, iWidth, iHeight, uiSubSampExpX, uiSubSampExpY, rpcYuvPred, uiRShift, 0 );
+#if PDM_REMOVE_DEPENDENCE
+    if( pcCU->getPic()->getStoredPDMforV2() == 1 )
+      xPredInterPrdDepthMap( pcCU, pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPredDepthMapTemp(), uiPartAddr, &cMv, iWidth, iHeight, uiSubSampExpX, uiSubSampExpY, rpcYuvPred, uiRShift, 0 );
+    else
+#endif
+      xPredInterPrdDepthMap( pcCU, pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPredDepthMap(), uiPartAddr, &cMv, iWidth, iHeight, uiSubSampExpX, uiSubSampExpY, rpcYuvPred, uiRShift, 0 );
+
     return;
   }
Index: trunk/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 100)
@@ -125,4 +125,9 @@
 #endif
 
+#if LGE_EDGE_INTRA
+  Pel  xGetNearestNeighbor  ( Int x, Int y, Int* pSrc, Int srcStride, Int iWidth, Int iHeight, Bool* bpRegion );
+  Void xPredIntraEdge       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, Bool bDelta = false );
+#endif
+
 public:
   TComPrediction();
@@ -170,4 +175,7 @@
   Bool  getWedgePatternIdx      ( WedgeRefList* pcWedgeRefList, UInt& ruiTabIdx, UChar uhXs, UChar uhYs, UChar uhXe, UChar uhYe );
 #endif
+#if LGE_EDGE_INTRA
+  Void predIntraLumaEdge          ( TComDataCU* pcCU, TComPattern* pcTComPattern, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Pel* piPred, UInt uiStride, Bool bDelta = false );
+#endif
 
   // simplified intra pred for "virtual" depth maps
Index: trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 100)
@@ -45,4 +45,8 @@
 //! \{
 
+#if SAIT_VSO_EST_A0033
+Double TComRdCost::m_dDisparityCoeff = 1.0;
+#endif
+
 TComRdCost::TComRdCost()
 {
@@ -232,4 +236,14 @@
   m_afpDistortFunc[28] = TComRdCost::xGetHADs;
   
+#if SAIT_VSO_EST_A0033
+  m_afpDistortFunc[29]  = TComRdCost::xGetVSD;
+  m_afpDistortFunc[30]  = TComRdCost::xGetVSD4;
+  m_afpDistortFunc[31]  = TComRdCost::xGetVSD8;
+  m_afpDistortFunc[32]  = TComRdCost::xGetVSD16;
+  m_afpDistortFunc[33]  = TComRdCost::xGetVSD32;
+  m_afpDistortFunc[34]  = TComRdCost::xGetVSD64;
+  m_afpDistortFunc[35]  = TComRdCost::xGetVSD16N;
+#endif
+
 #if !FIX203
   m_puiComponentCostOriginP = NULL;
@@ -248,4 +262,7 @@
   m_uiNumberRefPics         = 0;
   m_bUseVSO                 = false;
+#if SAIT_VSO_EST_A0033
+  m_bUseEstimatedVSD        = false; 
+#endif
   m_uiVSOMode               = 0; 
   m_fpDistortFuncVSO        = NULL; 
@@ -273,23 +290,20 @@
     
     m_puiComponentCostOriginP = new UInt[ 4 * iSubPelSearchLimit ];
-#if HHI_FIX
     m_puiMultiviewRegCostHorOrgP  = new UInt[ 4 * iSubPelSearchLimit ];
     m_puiMultiviewRegCostVerOrgP  = new UInt[ 4 * iSubPelSearchLimit ];
-#endif
+
     iSubPelSearchLimit *= 2;
     
     m_puiComponentCost = m_puiComponentCostOriginP + iSubPelSearchLimit;
-#if HHI_FIX
+
     m_puiMultiviewRegCostHor = m_puiMultiviewRegCostHorOrgP + iSubPelSearchLimit;
     m_puiMultiviewRegCostVer = m_puiMultiviewRegCostVerOrgP + iSubPelSearchLimit;
-#endif
+
     
     for( Int n = -iSubPelSearchLimit; n < iSubPelSearchLimit; n++)
     {
       m_puiComponentCost[n] = xGetComponentBits( n );
-#if HHI_FIX
       m_puiMultiviewRegCostHor[n] = xGetComponentBits( n );  // first version
       m_puiMultiviewRegCostVer[n] = xGetComponentBits( n );  // first version
-#endif
     }
   }
@@ -303,5 +317,5 @@
     m_puiComponentCostOriginP = NULL;
   }
-#if HHI_FIX
+
   if( m_puiMultiviewRegCostHorOrgP )
     {
@@ -314,5 +328,4 @@
     m_puiMultiviewRegCostVerOrgP = NULL;
   }
-#endif
 }
 #endif
@@ -565,4 +578,27 @@
 }
 
+
+#if SAIT_VSO_EST_A0033
+UInt TComRdCost::getDistPart( Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, Pel* piVirRec, Pel* piVirOrg, Int iVirStride, UInt uiBlkWidth, UInt uiBlkHeight, DFunc eDFunc )
+{
+  AOT( ( m_dDisparityCoeff <= 0 ) || ( m_dDisparityCoeff > 10 ) );
+
+  DistParam cDtParam;
+  setDistParam( uiBlkWidth, uiBlkHeight, eDFunc, cDtParam );
+  cDtParam.pOrg       = piOrg;
+  cDtParam.pCur       = piCur;
+  cDtParam.pVirRec    = piVirRec;
+  cDtParam.pVirOrg    = piVirOrg;
+  cDtParam.iStrideVir = iVirStride;
+  cDtParam.iStrideOrg = iOrgStride;
+  cDtParam.iStrideCur = iCurStride;
+  cDtParam.iStep      = 1;
+
+  cDtParam.bApplyWeight = false;
+  cDtParam.uiComp       = 255;    // just for assert: to be sure it was set before use, since only values 0,1 or 2 are allowed.
+
+  return cDtParam.DistFunc( &cDtParam );
+}
+#endif
 
 
@@ -2026,4 +2062,235 @@
 #endif
 
+
+#if SAIT_VSO_EST_A0033
+UInt TComRdCost::getVSDEstimate( Int dDM, Pel* pOrg, Int iOrgStride,  Pel* pVirRec, Pel* pVirOrg, Int iVirStride, Int x, Int y )
+{
+  Double dD;
+  Int iTemp;
+
+  dD = ( (Double) ( dDM >> g_uiBitIncrement ) ) * m_dDisparityCoeff;
+
+  iTemp = (Int) ROUND( 0.5 * fabs(dD) * ( abs( (Int) pVirRec[ x+y*iVirStride ] - (Int) pVirRec[ x-1+y*iVirStride ] ) + abs( (Int) pVirRec[ x+y*iVirStride ] - (Int) pVirRec[ x+1+y*iVirStride ] ) ) );
+
+  return (UInt) ( (iTemp*iTemp)>>1 );
+}
+
+UInt TComRdCost::xGetVSD( DistParam* pcDtParam )
+{
+  Pel* piOrg    = pcDtParam->pOrg;
+  Pel* piCur    = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows    = pcDtParam->iRows;
+  Int  iCols    = pcDtParam->iCols;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < iCols; x++ )
+    {
+      dDM = (Int) ( piOrg[x  ] - piCur[x  ] );
+      uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x, y ) >> uiShift;
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur; 
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD4( DistParam* pcDtParam )
+{
+  Pel* piOrg   = pcDtParam->pOrg;
+  Pel* piCur   = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows   = pcDtParam->iRows;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    dDM = (Int) ( piOrg[0] - piCur[0] );  uiSum += ( getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, 0, y ) ) >> uiShift;
+    dDM = (Int) ( piOrg[1] - piCur[1] );  uiSum += ( getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, 1, y ) ) >> uiShift;
+    dDM = (Int) ( piOrg[2] - piCur[2] );  uiSum += ( getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, 2, y ) ) >> uiShift;
+    dDM = (Int) ( piOrg[3] - piCur[3] );  uiSum += ( getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, 3, y ) ) >> uiShift;
+
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD8( DistParam* pcDtParam )
+{
+  Pel* piOrg   = pcDtParam->pOrg;
+  Pel* piCur   = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows   = pcDtParam->iRows;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < 8; x++ )
+    {
+      dDM = (Int) ( piOrg[x] - piCur[x] );
+      uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x, y ) >> uiShift;
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD16( DistParam* pcDtParam )
+{
+  Pel* piOrg   = pcDtParam->pOrg;
+  Pel* piCur   = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows   = pcDtParam->iRows;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < 16; x++ )
+    {
+      dDM = (Int) ( piOrg[x] - piCur[x] );
+      uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x, y ) >> uiShift;
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD16N( DistParam* pcDtParam )
+{
+  Pel* piOrg   = pcDtParam->pOrg;
+  Pel* piCur   = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows   = pcDtParam->iRows;
+  Int  iCols   = pcDtParam->iCols;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < iCols; x+=16 )
+    {
+      for ( Int k = 0 ; k < 16 ; k++ )
+      {
+        dDM = (Int) ( piOrg[x+k] - piCur[x+k] );
+        uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x+k, y ) >> uiShift;
+      }
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD32( DistParam* pcDtParam )
+{
+  Pel* piOrg   = pcDtParam->pOrg;
+  Pel* piCur   = pcDtParam->pCur;
+  Pel* piVirRec = pcDtParam->pVirRec;
+  Pel* piVirOrg = pcDtParam->pVirOrg;
+  Int  iRows   = pcDtParam->iRows;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < 32 ; x++ )
+    {
+      dDM = (Int) ( piOrg[x] - piCur[x] );
+      uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x, y ) >> uiShift;
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+UInt TComRdCost::xGetVSD64( DistParam* pcDtParam )
+{
+  Pel* piOrg      = pcDtParam->pOrg;
+  Pel* piCur      = pcDtParam->pCur;
+  Pel* piVirRec   = pcDtParam->pVirRec;
+  Pel* piVirOrg   = pcDtParam->pVirOrg;
+  Int  iRows      = pcDtParam->iRows;
+  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  Int  iStrideCur = pcDtParam->iStrideCur;
+  Int  iStrideVir = pcDtParam->iStrideVir;
+
+  UInt uiSum = 0;
+  UInt uiShift = g_uiBitIncrement<<1;
+
+  Int dDM;
+
+  for ( Int y = 0 ; y < iRows ; y++ )
+  {
+    for (Int x = 0; x < 64; x++ )
+    {
+      dDM = (Int) ( piOrg[x] - piCur[x] );
+      uiSum += getVSDEstimate( dDM, piOrg, iStrideOrg, piVirRec, piVirOrg, iStrideVir, x, y ) >> uiShift;
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum );
+}
+
+#endif
+
 // --------------------------------------------------------------------------------------------------------------------
 // HADAMARD with step (used in fractional search)
@@ -2668,5 +2935,9 @@
 { 
   AOT(bSAD); 
+#ifdef LGE_VSO_EARLY_SKIP_A0093
+  RMDist iDist = m_pcRenModel->getDist( iStartPosX, iStartPosY, (Int) uiBlkWidth, (Int) uiBlkHeight, iCurStride, piCur, piOrg, iOrgStride);  
+#else
   RMDist iDist = m_pcRenModel->getDist( iStartPosX, iStartPosY, (Int) uiBlkWidth, (Int) uiBlkHeight, iCurStride, piCur );  
+#endif
 
   RMDist iDistMin = (RMDist) RDO_DIST_MIN; 
Index: trunk/source/Lib/TLibCommon/TComRdCost.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 100)
@@ -80,4 +80,9 @@
   Int   iStrideOrg;
   Int   iStrideCur;
+#if SAIT_VSO_EST_A0033
+  Pel*  pVirRec;
+  Pel*  pVirOrg;
+  Int   iStrideVir;
+#endif
   Int   iRows;
   Int   iCols;
@@ -105,4 +110,9 @@
     pOrg = NULL;
     pCur = NULL;
+#if SAIT_VSO_EST_A0033
+    pVirRec = NULL;
+    pVirOrg = NULL;;
+    iStrideVir = 0;
+#endif
     iStrideOrg = 0;
     iStrideCur = 0;
@@ -145,4 +155,7 @@
   UInt                    m_uiLambdaMotionSSE;
   Double                  m_dFrameLambda;
+#if SAIT_VSO_EST_A0033
+  static Double           m_dDisparityCoeff;
+#endif
   
 #if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
@@ -192,4 +205,9 @@
   Void    setFrameLambda ( Double dLambda ) { m_dFrameLambda = dLambda; }
   
+#if SAIT_VSO_EST_A0033
+  Void    setDisparityCoeff( Double dDisparityCoeff ) { m_dDisparityCoeff = dDisparityCoeff; }
+  Double  getDisparityCoeff()                         { return m_dDisparityCoeff; }
+#endif
+
 #if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
   Void   setLambdaScale  ( Double dLambdaScale) { m_dLambdaScale = dLambdaScale; }
@@ -222,7 +240,6 @@
 { 
      m_uiCost = (bSad ? m_uiLambdaMotionSAD + iAdd : m_uiLambdaMotionSSE + iAdd); 
-#if HHI_FIX
     m_uiLambdaMVReg = ( bSad ? m_uiLambdaMVRegSAD         : m_uiLambdaMVRegSSE         );
-#endif
+
    }
   Void    setPredictor( TComMv& rcMv )
@@ -301,4 +318,14 @@
   static UInt xGetSAD16N        ( DistParam* pcDtParam );
   
+#if SAIT_VSO_EST_A0033
+  static UInt xGetVSD           ( DistParam* pcDtParam );
+  static UInt xGetVSD4          ( DistParam* pcDtParam );
+  static UInt xGetVSD8          ( DistParam* pcDtParam );
+  static UInt xGetVSD16         ( DistParam* pcDtParam );
+  static UInt xGetVSD32         ( DistParam* pcDtParam );
+  static UInt xGetVSD64         ( DistParam* pcDtParam );
+  static UInt xGetVSD16N        ( DistParam* pcDtParam );
+#endif
+
 #if AMP_SAD
   static UInt xGetSAD12         ( DistParam* pcDtParam );
@@ -329,4 +356,9 @@
 #endif
   
+#if SAIT_VSO_EST_A0033
+  UInt   getDistPart( Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, Pel* piVirRec, Pel* piVirOrg, Int iVirStride, UInt uiBlkWidth, UInt uiBlkHeight, DFunc eDFunc = DF_VSD );
+  static UInt getVSDEstimate( Int dDM, Pel* pOrg, Int iOrgStride,  Pel* pVirRec, Pel* pVirOrg, Int iVirStride, Int x, Int y );
+#endif
+
 #if HHI_VSO
 private:
@@ -340,4 +372,9 @@
   Bool                    m_bAllowNegDist;
 #endif
+#if SAIT_VSO_EST_A0033
+  TComPicYuv *            m_pcVideoRecPicYuv;
+  TComPicYuv *            m_pcDepthPicYuv;
+  Bool                    m_bUseEstimatedVSD; 
+#endif
 
   Bool                    m_bUseVSO;
@@ -357,4 +394,13 @@
   Void    setUseVSO ( Bool bIn )         { m_bUseVSO = bIn; };
   Bool    getUseVSO ( )                  { return m_bUseVSO;};
+#if SAIT_VSO_EST_A0033
+  Bool    getUseEstimatedVSD( )           { return m_bUseEstimatedVSD; };
+  Void    setUseEstimatedVSD( Bool bIn )  { m_bUseEstimatedVSD = bIn; };
+
+  TComPicYuv* getVideoRecPicYuv ()                               { return m_pcVideoRecPicYuv; };
+  Void        setVideoRecPicYuv ( TComPicYuv* pcVideoRecPicYuv ) { m_pcVideoRecPicYuv = pcVideoRecPicYuv; };
+  TComPicYuv* getDepthPicYuv    ()                               { return m_pcDepthPicYuv; };
+  Void        setDepthPicYuv    ( TComPicYuv* pcDepthPicYuv )    { m_pcDepthPicYuv = pcDepthPicYuv; };
+#endif
 
   Bool    getUseRenModel ( )             { return (m_bUseVSO && m_uiVSOMode == 4); };
Index: trunk/source/Lib/TLibCommon/TComResidualGenerator.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComResidualGenerator.cpp	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComResidualGenerator.cpp	(revision 100)
@@ -219,5 +219,12 @@
 }
 
-
+#if QC_MULTI_DIS_CAN
+Bool
+TComResidualGenerator::getResidualSamples( TComDataCU* pcCU, UInt uiPUIdx, TComYuv* pcYuv, Int iDisp
+#if QC_SIMPLIFIEDIVRP_M24938
+  , Bool bRecon
+#endif
+ ) 
+#else
 Bool
 TComResidualGenerator::getResidualSamples( TComDataCU* pcCU, UInt uiPUIdx, TComYuv* pcYuv 
@@ -226,4 +233,5 @@
 #endif
   )
+#endif
 {
   AOF(  pcCU );
@@ -235,4 +243,11 @@
   iBlkHeight  = pcCU->getHeight ( 0 );
   pcCU->getPic()->getPicYuvRec()->getTopLeftSamplePos( pcCU->getAddr(), pcCU->getZorderIdxInCU() + uiPartAddr, iXPos, iYPos );
+#if QC_MULTI_DIS_CAN
+  return getResidualSamples( pcCU->getPic(), (UInt)iXPos, (UInt)iYPos, (UInt)iBlkWidth, (UInt)iBlkHeight, pcYuv, iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+    , bRecon
+#endif
+  );
+#else
   return getResidualSamples( pcCU->getPic(), (UInt)iXPos, (UInt)iYPos, (UInt)iBlkWidth, (UInt)iBlkHeight, pcYuv 
 #if QC_SIMPLIFIEDIVRP_M24938
@@ -240,6 +255,15 @@
 #endif
     );
+#endif
 }
   
+#if QC_MULTI_DIS_CAN
+Bool
+TComResidualGenerator::getResidualSamples( TComPic* pcPic, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv, Int iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+  , Bool bRecon
+#endif
+)
+#else
 Bool
 TComResidualGenerator::getResidualSamples( TComPic* pcPic, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv 
@@ -248,4 +272,5 @@
 #endif
   )
+#endif
 {
   UInt  uiBaseViewId  = m_pcDepthMapGenerator->getBaseViewId( 0 );
@@ -258,4 +283,11 @@
   UInt uiXPosInRefView = uiXPos , uiYPosInRefView = uiYPos;
 #endif
+#if QC_MULTI_DIS_CAN
+  xSetPredResidualBlock( pcPic, uiBaseViewId, uiXPos, uiYPos, uiBlkWidth, uiBlkHeight, pcYuv, iDisp
+#if QC_SIMPLIFIEDIVRP_M24938
+    , &uiXPosInRefView , &uiYPosInRefView , bRecon
+#endif  
+  );
+#else
   xSetPredResidualBlock( pcPic, uiBaseViewId, uiXPos, uiYPos, uiBlkWidth, uiBlkHeight, pcYuv 
 #if QC_SIMPLIFIEDIVRP_M24938
@@ -263,5 +295,5 @@
 #endif
     );
-
+#endif
 #if QC_SIMPLIFIEDIVRP_M24938
   return xIsNonZeroByCBF( uiBaseViewId , uiXPosInRefView , uiYPosInRefView , uiBlkWidth , uiBlkHeight );
@@ -423,6 +455,6 @@
     AOF( bOK );
 #if LG_RESTRICTEDRESPRED_M24766
-	pcCU->getPUResiPredShift(iPUPredResiShift, 0);
-	pcCUResidual->add(iPUPredResiShift, pcCU->getPartitionSize(0), m_ppcYuvTmp[0], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
+    pcCU->getPUResiPredShift(iPUPredResiShift, 0);
+    pcCUResidual->add(iPUPredResiShift, pcCU->getPartitionSize(0), m_ppcYuvTmp[0], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
 #else
     pcCUResidual->add( m_ppcYuvTmp[0], pcCU->getWidth( 0 ), pcCU->getHeight( 0 ) );
@@ -485,5 +517,12 @@
 
 
-
+#if QC_MULTI_DIS_CAN
+Void  
+TComResidualGenerator::xSetPredResidualBlock( TComPic* pcPic, UInt uiBaseViewId, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv, Int iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+  , UInt * puiXPosInRefView , UInt * puiYPosInRefView , Bool bRecon
+#endif
+)
+#else
 Void  
 TComResidualGenerator::xSetPredResidualBlock( TComPic* pcPic, UInt uiBaseViewId, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv 
@@ -492,4 +531,5 @@
 #endif
   )
+#endif
 {
   //===== set and check some basic variables =====
@@ -508,8 +548,11 @@
 
   //===== get disparity =====
+#if QC_MULTI_DIS_CAN
+  Int iDisparity = iDisp;
+#else
   Int           iMidPosX    = Int( uiXPos + ( ( uiBlkWidth  - 1 ) >> 1 ) ) >> m_pcDepthMapGenerator->getSubSampExpX();
   Int           iMidPosY    = Int( uiYPos + ( ( uiBlkHeight - 1 ) >> 1 ) ) >> m_pcDepthMapGenerator->getSubSampExpY();
   Int           iDisparity  = m_pcDepthMapGenerator->getDisparity( pcPic, iMidPosX, iMidPosY, uiBaseViewId );
-
+#endif
   //===== compensate luma =====
   Int           iYWidth     = Int( uiBlkWidth  );
Index: trunk/source/Lib/TLibCommon/TComResidualGenerator.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComResidualGenerator.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComResidualGenerator.h	(revision 100)
@@ -69,4 +69,16 @@
   Void  setRecResidualPic     ( TComPic*      pcPic );
 
+#if QC_MULTI_DIS_CAN
+  Bool  getResidualSamples    ( TComDataCU*   pcCU,  UInt uiPUIdx, TComYuv* pcYuv, Int iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+    , Bool bRecon
+#endif
+);
+  Bool  getResidualSamples    ( TComPic* pcPic, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv , Int iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+    , Bool bRecon
+#endif  
+  );
+#else
   Bool  getResidualSamples    ( TComDataCU*   pcCU,  UInt uiPUIdx, TComYuv* pcYuv 
 #if QC_SIMPLIFIEDIVRP_M24938
@@ -79,4 +91,5 @@
 #endif
     );
+#endif
 
 private:
@@ -87,5 +100,11 @@
   Void  xClearIntViewResidual ( TComDataCU*   pcCU,  TComYuv* pcCUResidual, UInt uiPartIdx    );
   Void  xClearResidual        (                      TComYuv* pcCUResidual, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight );
-
+#if QC_MULTI_DIS_CAN
+  Void  xSetPredResidualBlock ( TComPic*      pcPic, UInt uiBaseViewId, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv, Int iDisp 
+#if QC_SIMPLIFIEDIVRP_M24938
+    , UInt * puiXPosInRefView , UInt * puiYPosInRefView , Bool bRecon
+#endif
+  );
+#else
   Void  xSetPredResidualBlock ( TComPic*      pcPic, UInt uiBaseViewId, UInt uiXPos, UInt uiYPos, UInt uiBlkWidth, UInt uiBlkHeight, TComYuv* pcYuv 
 #if QC_SIMPLIFIEDIVRP_M24938
@@ -93,4 +112,5 @@
 #endif
     );
+#endif
   Bool  xIsNonZero            ( TComYuv*      pcYuv, UInt uiBlkWidth, UInt uiBlkHeight );
 #if QC_SIMPLIFIEDIVRP_M24938
Index: trunk/source/Lib/TLibCommon/TComRom.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComRom.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComRom.h	(revision 100)
@@ -206,4 +206,10 @@
 #endif
 
+#if LGE_EDGE_INTRA
+__inline Void mapEdgeIntratoDC( UChar& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+__inline Void mapEdgeIntratoDC(  UInt& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+__inline Void mapEdgeIntratoDC(   Int& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+#endif
+
 // ==========================================
 // Mode-Dependent DST Matrices
Index: trunk/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComYuv.h	(revision 81)
+++ trunk/source/Lib/TLibCommon/TComYuv.h	(revision 100)
@@ -167,5 +167,5 @@
   Void    removeHighFreq    ( TComYuv* pcYuvSrc, UInt uiPartIdx, UInt uiWidht, UInt uiHeight );
 #if LG_RESTRICTEDRESPRED_M24766
-  void	  getPUXYOffset     (PartSize uhPartitionSize, Int iWidth, Int iHeight, Int &iXOffset, Int &iYOffset);
+  Void    getPUXYOffset     (PartSize uhPartitionSize, Int iWidth, Int iHeight, Int &iXOffset, Int &iYOffset);
   Void    add               (Int *iPUResiPredShift, PartSize uhPartitionSize, TComYuv* pcYuvAdd, Int iWidth, Int iHeight, Bool bSubtract = false );
   Void    addLuma           (Int *iPUResiPredShift, PartSize uhPartitionSize, TComYuv* pcYuvAdd, Int iWidth, Int iHeight, Bool bSubtract );
